__gnu_pbds::detail::synth_access_traits< Type_Traits, Set, _ATraits > Struct Template Reference

`#include <synth_access_traits.hpp>`

Inherits _ATraits.

## Public Types

typedef _ATraits | base_type
typedef base_type::const_iterator | const_iterator
typedef type_traits::const_reference | const_reference
typedef type_traits::key_const_reference | key_const_reference
typedef Type_Traits | type_traits

## Public Member Functions

| synth_access_traits (const base_type &)
bool | cmp_keys (key_const_reference, key_const_reference) const
bool | cmp_prefixes (const_iterator, const_iterator, const_iterator, const_iterator, bool compare_after=false) const
bool | equal_keys (key_const_reference, key_const_reference) const
bool | equal_prefixes (const_iterator, const_iterator, const_iterator, const_iterator, bool compare_after=true) const

## Static Public Member Functions

static key_const_reference | extract_key (const_reference)

## Detailed Description

template<typename Type_Traits, bool Set, typename _ATraits>
struct __gnu_pbds::detail::synth_access_traits< Type_Traits, Set, _ATraits >

Synthetic element access traits.

Definition at line 59 of file synth_access_traits.hpp.

## Member Typedef Documentation

## base_type

template<typename Type_Traits , bool Set, typename _ATraits >

typedef _ATraits __gnu_pbds::detail::synth_access_traits< Type_Traits, Set, _ATraits >::base_type

Definition at line 61 of file synth_access_traits.hpp.

## const_iterator

template<typename Type_Traits , bool Set, typename _ATraits >

typedef base_type::const_iterator __gnu_pbds::detail::synth_access_traits< Type_Traits, Set, _ATraits >::const_iterator

Definition at line 62 of file synth_access_traits.hpp.

## const_reference

template<typename Type_Traits , bool Set, typename _ATraits >

typedef type_traits::const_reference __gnu_pbds::detail::synth_access_traits< Type_Traits, Set, _ATraits >::const_reference

Definition at line 64 of file synth_access_traits.hpp.

## key_const_reference

template<typename Type_Traits , bool Set, typename _ATraits >

typedef type_traits::key_const_reference __gnu_pbds::detail::synth_access_traits< Type_Traits, Set, _ATraits >::key_const_reference

Definition at line 65 of file synth_access_traits.hpp.

## type_traits

template<typename Type_Traits , bool Set, typename _ATraits >

typedef Type_Traits __gnu_pbds::detail::synth_access_traits< Type_Traits, Set, _ATraits >::type_traits

Definition at line 63 of file synth_access_traits.hpp.

## Constructor & Destructor Documentation

## synth_access_traits() [1/2]

template<typename Type_Traits , bool Set, typename _ATraits >

__gnu_pbds::detail::synth_access_traits< Type_Traits, Set, _ATraits >::synth_access_traits | ( |  | ) |

Definition at line 108 of file synth_access_traits.hpp.

## synth_access_traits() [2/2]

template<typename Type_Traits , bool Set, typename _ATraits >

__gnu_pbds::detail::synth_access_traits< Type_Traits, Set, _ATraits >::synth_access_traits | ( | const base_type & | r_traits | ) |

Definition at line 113 of file synth_access_traits.hpp.

## Member Function Documentation

## cmp_keys()

template<typename Type_Traits , bool Set, typename _ATraits >

bool __gnu_pbds::detail::synth_access_traits< Type_Traits, Set, _ATraits >::cmp_keys | ( | key_const_reference | r_lhs_key,
|  | key_const_reference | r_rhs_key
| ) |  | const

Definition at line 175 of file synth_access_traits.hpp.

## cmp_prefixes()

template<typename Type_Traits , bool Set, typename _ATraits >

bool __gnu_pbds::detail::synth_access_traits< Type_Traits, Set, _ATraits >::cmp_prefixes | ( | const_iterator | b_l,
|  | const_iterator | e_l,
|  | const_iterator | b_r,
|  | const_iterator | e_r,
|  | bool | compare_after = `false`
| ) |  | const

Definition at line 151 of file synth_access_traits.hpp.

## equal_keys()

template<typename Type_Traits , bool Set, typename _ATraits >

bool __gnu_pbds::detail::synth_access_traits< Type_Traits, Set, _ATraits >::equal_keys | ( | key_const_reference | r_lhs_key,
|  | key_const_reference | r_rhs_key
| ) |  | const

Definition at line 138 of file synth_access_traits.hpp.

## equal_prefixes()

template<typename Type_Traits , bool Set, typename _ATraits >

bool __gnu_pbds::detail::synth_access_traits< Type_Traits, Set, _ATraits >::equal_prefixes | ( | const_iterator | b_l,
|  | const_iterator | e_l,
|  | const_iterator | b_r,
|  | const_iterator | e_r,
|  | bool | compare_after = `true`
| ) |  | const

inline

Definition at line 120 of file synth_access_traits.hpp.

## extract_key()

template<typename Type_Traits , bool Set, typename _ATraits >

synth_access_traits< Type_Traits, Set, _ATraits >::key_const_reference __gnu_pbds::detail::synth_access_traits< Type_Traits, Set, _ATraits >::extract_key | ( | const_reference | r_val | ) |

inline static

Definition at line 188 of file synth_access_traits.hpp.

The documentation for this struct was generated from the following file:

- synth_access_traits.hpp